<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptableCardType StructType
 * @subpackage Structs
 */
class AcceptableCardType extends AbstractStructBase
{
    /**
     * The AcceptableCardTypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AcceptableCardTypeID;
    /**
     * The AcceptableCardTypeName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AcceptableCardTypeName;
    /**
     * Constructor method for AcceptableCardType
     * @uses AcceptableCardType::setAcceptableCardTypeID()
     * @uses AcceptableCardType::setAcceptableCardTypeName()
     * @param string $acceptableCardTypeID
     * @param string $acceptableCardTypeName
     */
    public function __construct($acceptableCardTypeID = null, $acceptableCardTypeName = null)
    {
        $this
            ->setAcceptableCardTypeID($acceptableCardTypeID)
            ->setAcceptableCardTypeName($acceptableCardTypeName);
    }
    /**
     * Get AcceptableCardTypeID value
     * @return string
     */
    public function getAcceptableCardTypeID()
    {
        return $this->AcceptableCardTypeID;
    }
    /**
     * Set AcceptableCardTypeID value
     * @param string $acceptableCardTypeID
     * @return \StructType\AcceptableCardType
     */
    public function setAcceptableCardTypeID($acceptableCardTypeID = null)
    {
        // validation for constraint: string
        if (!is_null($acceptableCardTypeID) && !is_string($acceptableCardTypeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($acceptableCardTypeID)), __LINE__);
        }
        $this->AcceptableCardTypeID = $acceptableCardTypeID;
        return $this;
    }
    /**
     * Get AcceptableCardTypeName value
     * @return string
     */
    public function getAcceptableCardTypeName()
    {
        return $this->AcceptableCardTypeName;
    }
    /**
     * Set AcceptableCardTypeName value
     * @param string $acceptableCardTypeName
     * @return \StructType\AcceptableCardType
     */
    public function setAcceptableCardTypeName($acceptableCardTypeName = null)
    {
        // validation for constraint: string
        if (!is_null($acceptableCardTypeName) && !is_string($acceptableCardTypeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($acceptableCardTypeName)), __LINE__);
        }
        $this->AcceptableCardTypeName = $acceptableCardTypeName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AcceptableCardType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
