<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptableCardTypes StructType
 * @subpackage Structs
 */
class AcceptableCardTypes extends AbstractStructBase
{
    /**
     * The AcceptableCardType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AcceptableCardType[]
     */
    public $AcceptableCardType;
    /**
     * Constructor method for AcceptableCardTypes
     * @uses AcceptableCardTypes::setAcceptableCardType()
     * @param \StructType\AcceptableCardType[] $acceptableCardType
     */
    public function __construct(array $acceptableCardType = array())
    {
        $this
            ->setAcceptableCardType($acceptableCardType);
    }
    /**
     * Get AcceptableCardType value
     * @return \StructType\AcceptableCardType[]|null
     */
    public function getAcceptableCardType()
    {
        return $this->AcceptableCardType;
    }
    /**
     * Set AcceptableCardType value
     * @throws \InvalidArgumentException
     * @param \StructType\AcceptableCardType[] $acceptableCardType
     * @return \StructType\AcceptableCardTypes
     */
    public function setAcceptableCardType(array $acceptableCardType = array())
    {
        foreach ($acceptableCardType as $acceptableCardTypesAcceptableCardTypeItem) {
            // validation for constraint: itemType
            if (!$acceptableCardTypesAcceptableCardTypeItem instanceof \StructType\AcceptableCardType) {
                throw new \InvalidArgumentException(sprintf('The AcceptableCardType property can only contain items of \StructType\AcceptableCardType, "%s" given', is_object($acceptableCardTypesAcceptableCardTypeItem) ? get_class($acceptableCardTypesAcceptableCardTypeItem) : gettype($acceptableCardTypesAcceptableCardTypeItem)), __LINE__);
            }
        }
        $this->AcceptableCardType = $acceptableCardType;
        return $this;
    }
    /**
     * Add item to AcceptableCardType value
     * @throws \InvalidArgumentException
     * @param \StructType\AcceptableCardType $item
     * @return \StructType\AcceptableCardTypes
     */
    public function addToAcceptableCardType(\StructType\AcceptableCardType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AcceptableCardType) {
            throw new \InvalidArgumentException(sprintf('The AcceptableCardType property can only contain items of \StructType\AcceptableCardType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AcceptableCardType[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AcceptableCardTypes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
