<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelOrderReasons StructType
 * @subpackage Structs
 */
class CancelOrderReasons extends AbstractStructBase
{
    /**
     * The Reason
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var string[]
     */
    public $Reason;
    /**
     * Constructor method for CancelOrderReasons
     * @uses CancelOrderReasons::setReason()
     * @param string[] $reason
     */
    public function __construct(array $reason = array())
    {
        $this
            ->setReason($reason);
    }
    /**
     * Get Reason value
     * @return string[]
     */
    public function getReason()
    {
        return $this->Reason;
    }
    /**
     * Set Reason value
     * @throws \InvalidArgumentException
     * @param string[] $reason
     * @return \StructType\CancelOrderReasons
     */
    public function setReason(array $reason = array())
    {
        foreach ($reason as $cancelOrderReasonsReasonItem) {
            // validation for constraint: itemType
            if (!is_string($cancelOrderReasonsReasonItem)) {
                throw new \InvalidArgumentException(sprintf('The Reason property can only contain items of string, "%s" given', is_object($cancelOrderReasonsReasonItem) ? get_class($cancelOrderReasonsReasonItem) : gettype($cancelOrderReasonsReasonItem)), __LINE__);
            }
        }
        $this->Reason = $reason;
        return $this;
    }
    /**
     * Add item to Reason value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\CancelOrderReasons
     */
    public function addToReason($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The Reason property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Reason[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelOrderReasons
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
