<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderAmounts StructType
 * @subpackage Structs
 */
class OrderAmounts extends AbstractStructBase
{
    /**
     * The MenuAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MenuAmount;
    /**
     * The DiscountAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DiscountAmount;
    /**
     * The SurchargeAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeAmount;
    /**
     * The AdjustmentAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AdjustmentAmount;
    /**
     * The NetAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NetAmount;
    /**
     * The TaxAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TaxAmount;
    /**
     * The Tax1Amount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tax1Amount;
    /**
     * The Tax2Amount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tax2Amount;
    /**
     * The BottleAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BottleAmount;
    /**
     * The CustomerAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerAmount;
    /**
     * The PaymentAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PaymentAmount;
    /**
     * The CashAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CashAmount;
    /**
     * The TipAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TipAmount;
    /**
     * The CollectedFromCustomerAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CollectedFromCustomerAmount;
    /**
     * Constructor method for OrderAmounts
     * @uses OrderAmounts::setMenuAmount()
     * @uses OrderAmounts::setDiscountAmount()
     * @uses OrderAmounts::setSurchargeAmount()
     * @uses OrderAmounts::setAdjustmentAmount()
     * @uses OrderAmounts::setNetAmount()
     * @uses OrderAmounts::setTaxAmount()
     * @uses OrderAmounts::setTax1Amount()
     * @uses OrderAmounts::setTax2Amount()
     * @uses OrderAmounts::setBottleAmount()
     * @uses OrderAmounts::setCustomerAmount()
     * @uses OrderAmounts::setPaymentAmount()
     * @uses OrderAmounts::setCashAmount()
     * @uses OrderAmounts::setTipAmount()
     * @uses OrderAmounts::setCollectedFromCustomerAmount()
     * @param string $menuAmount
     * @param string $discountAmount
     * @param string $surchargeAmount
     * @param string $adjustmentAmount
     * @param string $netAmount
     * @param string $taxAmount
     * @param string $tax1Amount
     * @param string $tax2Amount
     * @param string $bottleAmount
     * @param string $customerAmount
     * @param string $paymentAmount
     * @param string $cashAmount
     * @param string $tipAmount
     * @param string $collectedFromCustomerAmount
     */
    public function __construct($menuAmount = null, $discountAmount = null, $surchargeAmount = null, $adjustmentAmount = null, $netAmount = null, $taxAmount = null, $tax1Amount = null, $tax2Amount = null, $bottleAmount = null, $customerAmount = null, $paymentAmount = null, $cashAmount = null, $tipAmount = null, $collectedFromCustomerAmount = null)
    {
        $this
            ->setMenuAmount($menuAmount)
            ->setDiscountAmount($discountAmount)
            ->setSurchargeAmount($surchargeAmount)
            ->setAdjustmentAmount($adjustmentAmount)
            ->setNetAmount($netAmount)
            ->setTaxAmount($taxAmount)
            ->setTax1Amount($tax1Amount)
            ->setTax2Amount($tax2Amount)
            ->setBottleAmount($bottleAmount)
            ->setCustomerAmount($customerAmount)
            ->setPaymentAmount($paymentAmount)
            ->setCashAmount($cashAmount)
            ->setTipAmount($tipAmount)
            ->setCollectedFromCustomerAmount($collectedFromCustomerAmount);
    }
    /**
     * Get MenuAmount value
     * @return string|null
     */
    public function getMenuAmount()
    {
        return $this->MenuAmount;
    }
    /**
     * Set MenuAmount value
     * @param string $menuAmount
     * @return \StructType\OrderAmounts
     */
    public function setMenuAmount($menuAmount = null)
    {
        // validation for constraint: string
        if (!is_null($menuAmount) && !is_string($menuAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($menuAmount)), __LINE__);
        }
        $this->MenuAmount = $menuAmount;
        return $this;
    }
    /**
     * Get DiscountAmount value
     * @return string|null
     */
    public function getDiscountAmount()
    {
        return $this->DiscountAmount;
    }
    /**
     * Set DiscountAmount value
     * @param string $discountAmount
     * @return \StructType\OrderAmounts
     */
    public function setDiscountAmount($discountAmount = null)
    {
        // validation for constraint: string
        if (!is_null($discountAmount) && !is_string($discountAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($discountAmount)), __LINE__);
        }
        $this->DiscountAmount = $discountAmount;
        return $this;
    }
    /**
     * Get SurchargeAmount value
     * @return string|null
     */
    public function getSurchargeAmount()
    {
        return $this->SurchargeAmount;
    }
    /**
     * Set SurchargeAmount value
     * @param string $surchargeAmount
     * @return \StructType\OrderAmounts
     */
    public function setSurchargeAmount($surchargeAmount = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeAmount) && !is_string($surchargeAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($surchargeAmount)), __LINE__);
        }
        $this->SurchargeAmount = $surchargeAmount;
        return $this;
    }
    /**
     * Get AdjustmentAmount value
     * @return string|null
     */
    public function getAdjustmentAmount()
    {
        return $this->AdjustmentAmount;
    }
    /**
     * Set AdjustmentAmount value
     * @param string $adjustmentAmount
     * @return \StructType\OrderAmounts
     */
    public function setAdjustmentAmount($adjustmentAmount = null)
    {
        // validation for constraint: string
        if (!is_null($adjustmentAmount) && !is_string($adjustmentAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($adjustmentAmount)), __LINE__);
        }
        $this->AdjustmentAmount = $adjustmentAmount;
        return $this;
    }
    /**
     * Get NetAmount value
     * @return string|null
     */
    public function getNetAmount()
    {
        return $this->NetAmount;
    }
    /**
     * Set NetAmount value
     * @param string $netAmount
     * @return \StructType\OrderAmounts
     */
    public function setNetAmount($netAmount = null)
    {
        // validation for constraint: string
        if (!is_null($netAmount) && !is_string($netAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($netAmount)), __LINE__);
        }
        $this->NetAmount = $netAmount;
        return $this;
    }
    /**
     * Get TaxAmount value
     * @return string|null
     */
    public function getTaxAmount()
    {
        return $this->TaxAmount;
    }
    /**
     * Set TaxAmount value
     * @param string $taxAmount
     * @return \StructType\OrderAmounts
     */
    public function setTaxAmount($taxAmount = null)
    {
        // validation for constraint: string
        if (!is_null($taxAmount) && !is_string($taxAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($taxAmount)), __LINE__);
        }
        $this->TaxAmount = $taxAmount;
        return $this;
    }
    /**
     * Get Tax1Amount value
     * @return string|null
     */
    public function getTax1Amount()
    {
        return $this->Tax1Amount;
    }
    /**
     * Set Tax1Amount value
     * @param string $tax1Amount
     * @return \StructType\OrderAmounts
     */
    public function setTax1Amount($tax1Amount = null)
    {
        // validation for constraint: string
        if (!is_null($tax1Amount) && !is_string($tax1Amount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tax1Amount)), __LINE__);
        }
        $this->Tax1Amount = $tax1Amount;
        return $this;
    }
    /**
     * Get Tax2Amount value
     * @return string|null
     */
    public function getTax2Amount()
    {
        return $this->Tax2Amount;
    }
    /**
     * Set Tax2Amount value
     * @param string $tax2Amount
     * @return \StructType\OrderAmounts
     */
    public function setTax2Amount($tax2Amount = null)
    {
        // validation for constraint: string
        if (!is_null($tax2Amount) && !is_string($tax2Amount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tax2Amount)), __LINE__);
        }
        $this->Tax2Amount = $tax2Amount;
        return $this;
    }
    /**
     * Get BottleAmount value
     * @return string|null
     */
    public function getBottleAmount()
    {
        return $this->BottleAmount;
    }
    /**
     * Set BottleAmount value
     * @param string $bottleAmount
     * @return \StructType\OrderAmounts
     */
    public function setBottleAmount($bottleAmount = null)
    {
        // validation for constraint: string
        if (!is_null($bottleAmount) && !is_string($bottleAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bottleAmount)), __LINE__);
        }
        $this->BottleAmount = $bottleAmount;
        return $this;
    }
    /**
     * Get CustomerAmount value
     * @return string|null
     */
    public function getCustomerAmount()
    {
        return $this->CustomerAmount;
    }
    /**
     * Set CustomerAmount value
     * @param string $customerAmount
     * @return \StructType\OrderAmounts
     */
    public function setCustomerAmount($customerAmount = null)
    {
        // validation for constraint: string
        if (!is_null($customerAmount) && !is_string($customerAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerAmount)), __LINE__);
        }
        $this->CustomerAmount = $customerAmount;
        return $this;
    }
    /**
     * Get PaymentAmount value
     * @return string|null
     */
    public function getPaymentAmount()
    {
        return $this->PaymentAmount;
    }
    /**
     * Set PaymentAmount value
     * @param string $paymentAmount
     * @return \StructType\OrderAmounts
     */
    public function setPaymentAmount($paymentAmount = null)
    {
        // validation for constraint: string
        if (!is_null($paymentAmount) && !is_string($paymentAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($paymentAmount)), __LINE__);
        }
        $this->PaymentAmount = $paymentAmount;
        return $this;
    }
    /**
     * Get CashAmount value
     * @return string|null
     */
    public function getCashAmount()
    {
        return $this->CashAmount;
    }
    /**
     * Set CashAmount value
     * @param string $cashAmount
     * @return \StructType\OrderAmounts
     */
    public function setCashAmount($cashAmount = null)
    {
        // validation for constraint: string
        if (!is_null($cashAmount) && !is_string($cashAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cashAmount)), __LINE__);
        }
        $this->CashAmount = $cashAmount;
        return $this;
    }
    /**
     * Get TipAmount value
     * @return string|null
     */
    public function getTipAmount()
    {
        return $this->TipAmount;
    }
    /**
     * Set TipAmount value
     * @param string $tipAmount
     * @return \StructType\OrderAmounts
     */
    public function setTipAmount($tipAmount = null)
    {
        // validation for constraint: string
        if (!is_null($tipAmount) && !is_string($tipAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tipAmount)), __LINE__);
        }
        $this->TipAmount = $tipAmount;
        return $this;
    }
    /**
     * Get CollectedFromCustomerAmount value
     * @return string|null
     */
    public function getCollectedFromCustomerAmount()
    {
        return $this->CollectedFromCustomerAmount;
    }
    /**
     * Set CollectedFromCustomerAmount value
     * @param string $collectedFromCustomerAmount
     * @return \StructType\OrderAmounts
     */
    public function setCollectedFromCustomerAmount($collectedFromCustomerAmount = null)
    {
        // validation for constraint: string
        if (!is_null($collectedFromCustomerAmount) && !is_string($collectedFromCustomerAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($collectedFromCustomerAmount)), __LINE__);
        }
        $this->CollectedFromCustomerAmount = $collectedFromCustomerAmount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OrderAmounts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
