<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OtherCardSettings StructType
 * @subpackage Structs
 */
class OtherCardSettings extends AbstractStructBase
{
    /**
     * The EPaymentProcessingTypeOLO
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $EPaymentProcessingTypeOLO;
    /**
     * The CVVEnabledLevel
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CVVEnabledLevel;
    /**
     * The IsAVSEnabled
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $IsAVSEnabled;
    /**
     * The IsGCPINRequired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $IsGCPINRequired;
    /**
     * The GCCardLength
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $GCCardLength;
    /**
     * The GCPINLength
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $GCPINLength;
    /**
     * Constructor method for OtherCardSettings
     * @uses OtherCardSettings::setEPaymentProcessingTypeOLO()
     * @uses OtherCardSettings::setCVVEnabledLevel()
     * @uses OtherCardSettings::setIsAVSEnabled()
     * @uses OtherCardSettings::setIsGCPINRequired()
     * @uses OtherCardSettings::setGCCardLength()
     * @uses OtherCardSettings::setGCPINLength()
     * @param string $ePaymentProcessingTypeOLO
     * @param string $cVVEnabledLevel
     * @param string $isAVSEnabled
     * @param string $isGCPINRequired
     * @param string $gCCardLength
     * @param string $gCPINLength
     */
    public function __construct($ePaymentProcessingTypeOLO = null, $cVVEnabledLevel = null, $isAVSEnabled = null, $isGCPINRequired = null, $gCCardLength = null, $gCPINLength = null)
    {
        $this
            ->setEPaymentProcessingTypeOLO($ePaymentProcessingTypeOLO)
            ->setCVVEnabledLevel($cVVEnabledLevel)
            ->setIsAVSEnabled($isAVSEnabled)
            ->setIsGCPINRequired($isGCPINRequired)
            ->setGCCardLength($gCCardLength)
            ->setGCPINLength($gCPINLength);
    }
    /**
     * Get EPaymentProcessingTypeOLO value
     * @return string
     */
    public function getEPaymentProcessingTypeOLO()
    {
        return $this->EPaymentProcessingTypeOLO;
    }
    /**
     * Set EPaymentProcessingTypeOLO value
     * @param string $ePaymentProcessingTypeOLO
     * @return \StructType\OtherCardSettings
     */
    public function setEPaymentProcessingTypeOLO($ePaymentProcessingTypeOLO = null)
    {
        // validation for constraint: string
        if (!is_null($ePaymentProcessingTypeOLO) && !is_string($ePaymentProcessingTypeOLO)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ePaymentProcessingTypeOLO)), __LINE__);
        }
        $this->EPaymentProcessingTypeOLO = $ePaymentProcessingTypeOLO;
        return $this;
    }
    /**
     * Get CVVEnabledLevel value
     * @return string
     */
    public function getCVVEnabledLevel()
    {
        return $this->CVVEnabledLevel;
    }
    /**
     * Set CVVEnabledLevel value
     * @param string $cVVEnabledLevel
     * @return \StructType\OtherCardSettings
     */
    public function setCVVEnabledLevel($cVVEnabledLevel = null)
    {
        // validation for constraint: string
        if (!is_null($cVVEnabledLevel) && !is_string($cVVEnabledLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cVVEnabledLevel)), __LINE__);
        }
        $this->CVVEnabledLevel = $cVVEnabledLevel;
        return $this;
    }
    /**
     * Get IsAVSEnabled value
     * @return string
     */
    public function getIsAVSEnabled()
    {
        return $this->IsAVSEnabled;
    }
    /**
     * Set IsAVSEnabled value
     * @param string $isAVSEnabled
     * @return \StructType\OtherCardSettings
     */
    public function setIsAVSEnabled($isAVSEnabled = null)
    {
        // validation for constraint: string
        if (!is_null($isAVSEnabled) && !is_string($isAVSEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($isAVSEnabled)), __LINE__);
        }
        $this->IsAVSEnabled = $isAVSEnabled;
        return $this;
    }
    /**
     * Get IsGCPINRequired value
     * @return string
     */
    public function getIsGCPINRequired()
    {
        return $this->IsGCPINRequired;
    }
    /**
     * Set IsGCPINRequired value
     * @param string $isGCPINRequired
     * @return \StructType\OtherCardSettings
     */
    public function setIsGCPINRequired($isGCPINRequired = null)
    {
        // validation for constraint: string
        if (!is_null($isGCPINRequired) && !is_string($isGCPINRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($isGCPINRequired)), __LINE__);
        }
        $this->IsGCPINRequired = $isGCPINRequired;
        return $this;
    }
    /**
     * Get GCCardLength value
     * @return string
     */
    public function getGCCardLength()
    {
        return $this->GCCardLength;
    }
    /**
     * Set GCCardLength value
     * @param string $gCCardLength
     * @return \StructType\OtherCardSettings
     */
    public function setGCCardLength($gCCardLength = null)
    {
        // validation for constraint: string
        if (!is_null($gCCardLength) && !is_string($gCCardLength)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($gCCardLength)), __LINE__);
        }
        $this->GCCardLength = $gCCardLength;
        return $this;
    }
    /**
     * Get GCPINLength value
     * @return string
     */
    public function getGCPINLength()
    {
        return $this->GCPINLength;
    }
    /**
     * Set GCPINLength value
     * @param string $gCPINLength
     * @return \StructType\OtherCardSettings
     */
    public function setGCPINLength($gCPINLength = null)
    {
        // validation for constraint: string
        if (!is_null($gCPINLength) && !is_string($gCPINLength)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($gCPINLength)), __LINE__);
        }
        $this->GCPINLength = $gCPINLength;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OtherCardSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
