<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceMethodHours StructType
 * @subpackage Structs
 */
class ServiceMethodHours extends AbstractStructBase
{
    /**
     * The Day
     * Meta informations extracted from the WSDL
     * - maxOccurs: 50
     * - minOccurs: 0
     * @var \StructType\Day[]
     */
    public $Day;
    /**
     * Constructor method for ServiceMethodHours
     * @uses ServiceMethodHours::setDay()
     * @param \StructType\Day[] $day
     */
    public function __construct(array $day = array())
    {
        $this
            ->setDay($day);
    }
    /**
     * Get Day value
     * @return \StructType\Day[]|null
     */
    public function getDay()
    {
        return $this->Day;
    }
    /**
     * Set Day value
     * @throws \InvalidArgumentException
     * @param \StructType\Day[] $day
     * @return \StructType\ServiceMethodHours
     */
    public function setDay(array $day = array())
    {
        foreach ($day as $serviceMethodHoursDayItem) {
            // validation for constraint: itemType
            if (!$serviceMethodHoursDayItem instanceof \StructType\Day) {
                throw new \InvalidArgumentException(sprintf('The Day property can only contain items of \StructType\Day, "%s" given', is_object($serviceMethodHoursDayItem) ? get_class($serviceMethodHoursDayItem) : gettype($serviceMethodHoursDayItem)), __LINE__);
            }
        }
        $this->Day = $day;
        return $this;
    }
    /**
     * Add item to Day value
     * @throws \InvalidArgumentException
     * @param \StructType\Day $item
     * @return \StructType\ServiceMethodHours
     */
    public function addToDay(\StructType\Day $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Day) {
            throw new \InvalidArgumentException(sprintf('The Day property can only contain items of \StructType\Day, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Day[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServiceMethodHours
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
