<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StoreServiceMethods StructType
 * @subpackage Structs
 */
class StoreServiceMethods extends AbstractStructBase
{
    /**
     * The StoreServiceMethod
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\StoreServiceMethod[]
     */
    public $StoreServiceMethod;
    /**
     * Constructor method for StoreServiceMethods
     * @uses StoreServiceMethods::setStoreServiceMethod()
     * @param \StructType\StoreServiceMethod[] $storeServiceMethod
     */
    public function __construct(array $storeServiceMethod = array())
    {
        $this
            ->setStoreServiceMethod($storeServiceMethod);
    }
    /**
     * Get StoreServiceMethod value
     * @return \StructType\StoreServiceMethod[]
     */
    public function getStoreServiceMethod()
    {
        return $this->StoreServiceMethod;
    }
    /**
     * Set StoreServiceMethod value
     * @throws \InvalidArgumentException
     * @param \StructType\StoreServiceMethod[] $storeServiceMethod
     * @return \StructType\StoreServiceMethods
     */
    public function setStoreServiceMethod(array $storeServiceMethod = array())
    {
        foreach ($storeServiceMethod as $storeServiceMethodsStoreServiceMethodItem) {
            // validation for constraint: itemType
            if (!$storeServiceMethodsStoreServiceMethodItem instanceof \StructType\StoreServiceMethod) {
                throw new \InvalidArgumentException(sprintf('The StoreServiceMethod property can only contain items of \StructType\StoreServiceMethod, "%s" given', is_object($storeServiceMethodsStoreServiceMethodItem) ? get_class($storeServiceMethodsStoreServiceMethodItem) : gettype($storeServiceMethodsStoreServiceMethodItem)), __LINE__);
            }
        }
        $this->StoreServiceMethod = $storeServiceMethod;
        return $this;
    }
    /**
     * Add item to StoreServiceMethod value
     * @throws \InvalidArgumentException
     * @param \StructType\StoreServiceMethod $item
     * @return \StructType\StoreServiceMethods
     */
    public function addToStoreServiceMethod(\StructType\StoreServiceMethod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StoreServiceMethod) {
            throw new \InvalidArgumentException(sprintf('The StoreServiceMethod property can only contain items of \StructType\StoreServiceMethod, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StoreServiceMethod[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StoreServiceMethods
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
